clear all;

akcie1 = xlsread('Akcie_data.xlsx','KB','D92:D1091');
akcie2 = xlsread('Akcie_data.xlsx','ERSTE','D92:D1091');

stredniHodnota1 = mean(akcie1(:,1));
rozptyl1 = var(akcie1(:,1));

stredniHodnota2 = mean(akcie2(:,1));
rozptyl2 = var(akcie2(:,1));

x = normcdf(akcie1(:,1),stredniHodnota1,rozptyl1);
y = normcdf(akcie2(:,1),stredniHodnota2,rozptyl2);

figure(1)
histfit(x)
%title('Normln rozdlen Akcie1')
xlabel('X')

figure(2)
histfit(y)
%title('Normln rozdlen Akcie2')
xlabel('Y')

figure(3)
scatterhist(x,y,'marker','.')
xlabel('X')
ylabel('Y')
%title('Sdruen marginln distribun funkce')

%transformace nhodnch veliin na definin obor kopule
u = ksdensity(x,x,'function','cdf');
v = ksdensity(y,y,'function','cdf');
n1 = length(u);
n2 = length(v); % n1 = n2
p = 1;

figure(4)
scatterhist(u,v,'marker','.')
xlabel('u')
ylabel('v')
%title('Sdruen marginln distribun funkce transformovanch veliin')


% Aproximace Claytonovou kopul
[theta_cl,nu_cl,l_cl] = copulafit2('Clayton',[u v]);
AIC_cl = ((2.*p)./n1)-((2.*l_cl)./n1);
AICc_cl = 2.*p.*(n1./(n1-p-1))-2.*l_cl;
BIC_cl = p.*log(n1)-2.*l_cl;

% Aproximace Frankovou kopul 
[theta_fr,nu_fr,l_fr] = copulafit2('Frank',[u v]);
AIC_fr = ((2.*p)./n1)-((2.*l_fr)./n1);
AICc_fr = 2.*p.*(n1./(n1-p-1))-2.*l_fr;
BIC_fr = p.*log(n1)-2.*l_fr;

% Aproximace Gumbelovou kopul
[theta_gh,nu_gh,l_gh] = copulafit2('Gumbel',[u v]);
AIC_gh = ((2.*p)./n1)-((2.*l_gh)./n1);
AICc_gh = 2.*p.*(n1./(n1-p-1))-2.*l_gh;
BIC_gh = p.*log(n1)-2.*l_gh;

% tabulka pro vyhodnocen nejlepho men
copula = {'Clayton';'Frank';'Gumbel'};
AIC = {AIC_cl;AIC_fr;AIC_gh};
AICc = {AICc_cl;AICc_fr;AICc_gh};
BIC = {BIC_cl;BIC_fr;BIC_gh};
theta = {theta_cl;theta_fr;theta_gh};
konfidencni_interval = {nu_cl;nu_fr;nu_gh};
tabulka = table(AIC,AICc,BIC,theta,konfidencni_interval,'RowNames',copula)

% generovn s parametry zvolen kopule
r = copularnd('Gumbel',theta_gh,1000);
u1 = r(:,1);
v1 = r(:,2);

figure(5)
scatterhist(u1,v1,'marker','.')
xlabel('u1')
ylabel('v1')
%title('Sdruen marginln distribun funkce vygenerovanch veliin')
set(get(gca,'children'),'marker','.')

% transformace dat zpt na pvodn mnoinu
x1 = ksdensity(x,u1,'function','icdf');
y1 = ksdensity(y,v1,'function','icdf');


figure(6)
scatterhist(x1,y1)
xlabel('x1')
ylabel('y1')
set(get(gca,'children'),'marker','.')
